import 'dart:developer';

import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter/material.dart';

Future<void> main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Firebase.initializeApp();
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: const MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({Key? key, required this.title}) : super(key: key);
  final String title;

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  FirebaseMessaging messaging = FirebaseMessaging.instance;
  String? body;
  String? title;

  @override
  void initState() {
    super.initState();
    messaging.getToken().then((value) {
      log(value.toString());
    });
    fcmFx();
  }

  fcmFx() {
    FirebaseMessaging.onMessage.listen((event) {
      setState(() {
        body = event.notification!.body;
        title = event.notification!.title;
      });

      log(body.toString());
    });

    /// This will happen when Local notification plugin used with FCM.
    FirebaseMessaging.onMessageOpenedApp.listen((message) {
      log('Message clicked!');
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            /// Here I called the title of our Message
            Text("The Title of FCM is $title"),

            /// Here I called the body the body of our Message.
            Text("The body of FCM is $body"),
            const Text(
              'You have pushed the button this many times:',
            ),
            Text('jjjj'),
          ],
        ),
      ),
    );
  }
}
